<?php

use QUI\ERP\Payments\Stripe\PaymentMethods\Recurring\Subscriptions;
use QUI\Utils\Security\Orthos;

/**
 * Cancel Paymill Subscription
 *
 * @param string $subscriptionId - Stripe Subscription ID
 * @return bool - success
 */
QUI::$Ajax->registerFunction(
    'package_quiqqer_payment-stripe_ajax_backend_settings_cancelSubscription',
    function ($subscriptionId) {
        $subscriptionId = Orthos::clear($subscriptionId);

        try {
            Subscriptions::cancelSubscription($subscriptionId);
        } catch (\Exception $Exception) {
            QUI\System\Log::writeException($Exception);

            QUI::getMessagesHandler()->addError(
                QUI::getLocale()->get(
                    'quiqqer/payment-stripe',
                    'message.ajax.backend.settings.cancelSubscription.error',
                    [
                        'subscriptionId' => $subscriptionId
                    ]
                )
            );

            return false;
        }

        QUI::getMessagesHandler()->addSuccess(
            QUI::getLocale()->get(
                'quiqqer/payment-stripe',
                'message.ajax.backend.settings.cancelSubscription.success',
                [
                    'subscriptionId' => $subscriptionId
                ]
            )
        );

        return true;
    },
    ['subscriptionId'],
    ['Permission::checkAdminUser', 'quiqqer.payments.stripe.subscriptions.cancel']
);
